package de.uni_passau.fim;

import android.bluetooth.BluetoothAdapter;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

/**
 * This class displays the start screen of the MasterMind app The user can
 * switch between single- and multiplayer mode. Note that multiplayer mode is
 * only available if a bluetooth adapter is found. This is currently not the
 * case on the emulator.
 * 
 */
public class StartScreen extends Activity implements View.OnClickListener {

	// the button to launch the single player activity
	private Button singlePlayer;
	
	// the button to launch the multi player activity
	private Button multiPlayer;

	private Button strategyEvaluator;
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.startscreen);

		singlePlayer = (Button) findViewById(R.id.singlePlayer);
		singlePlayer.setOnClickListener(this);

		multiPlayer = (Button) findViewById(R.id.multiPlayer);
		multiPlayer.setOnClickListener(this);
		
		strategyEvaluator = (Button) findViewById(R.id.strategyEvaluator);
		strategyEvaluator.setOnClickListener(this);
		
		// Task: Bluetooth 1
		// TODO: Enable the multiplayer button if Bluetooth is available on
		// a real device
		try {
			if (BluetoothAdapter.getDefaultAdapter() != null) {
				multiPlayer.setEnabled(true);
			}
			} catch (NoClassDefFoundError e) {
				
			}

	}

	/**
	 * Handles component interaction
	 * 
	 * @param v
	 *            The object which has been clicked
	 */
	public void onClick(View v) {
		if (singlePlayer.equals(v)) {
			MasterMind.setMpClass(null);
			Intent singlePlayerIntent = new Intent();
			singlePlayerIntent.setClassName("de.uni_passau.fim",
					"de.uni_passau.fim.MasterMind");
			startActivity(singlePlayerIntent);
		} else if (multiPlayer.equals(v)) {
			Multiplayer.setMasterMind(null);
			Intent multiPlayerIntent = new Intent();
			multiPlayerIntent.setClassName("de.uni_passau.fim",
					"de.uni_passau.fim.Multiplayer");
			startActivity(multiPlayerIntent);
		} else if (strategyEvaluator.equals(v)) {
			Intent evaluationIntent = new Intent();
			evaluationIntent.setClassName("de.uni_passau.fim", "de.uni_passau.fim.Evaluator");
			startActivity(evaluationIntent);
		}

	}
}
