package de.uni_passau.fim;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.InputType;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

public class StrategyConfig extends Activity {

	
	private LinearLayout dynamicConfigContainer;
	
	private Button OKButton;
	
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.strategyconfig);
		
		initDataViews();
		initButtonHandlers();
	}

	private void initButtonHandlers() {
		OKButton = (Button)findViewById(R.id.buttonEvalConfOK);
		OKButton.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				if (!isDataValid())
					return;
				updateIntentData();
				setResult(RESULT_OK, getIntent());
				finish();
			}
		});
	}

	private boolean isDataValid() {
		Intent intent = getIntent();
		int[] protoArray = intent.getIntArrayExtra(Evaluator.INTENT_DATA_VALUES);
		if (protoArray == null)
			return true;
		
		int size = protoArray.length;
		int cc = dynamicConfigContainer.getChildCount();
		int currPos = 0;
		for (int i=0; i<cc; i++) {
			View currView = dynamicConfigContainer.getChildAt(i);
			if (currPos >= size)
				throw new RuntimeException("StrategyConf.updateIntentData: Got more EditText fields than necessary.");
			if (currView instanceof EditText) {
				try {
					Integer.parseInt(((EditText)currView).getText().toString());
				} catch (Exception e) {
					((EditText)currView).requestFocus();
					return false;
				}
				currPos++;
			}
		}
		return true;
	}
	
	private void updateIntentData() {
		Intent intent = getIntent();
		
		int[] protoArray = intent.getIntArrayExtra(Evaluator.INTENT_DATA_VALUES);
		if (protoArray == null)
			return;
		int size = protoArray.length;
		int[] v = new int[size];
		int currPos = 0;
		int cc = dynamicConfigContainer.getChildCount();
		for (int i=0; i<cc; i++) {
			View currView = dynamicConfigContainer.getChildAt(i);
			if (currPos >= size)
				throw new RuntimeException("StrategyConf.updateIntentData: Got more EditText fields than necessary.");
			if (currView instanceof EditText) {
				v[currPos] = Integer.parseInt(((EditText)currView).getText().toString());
				currPos++;
			}
		}
		intent.putExtra(Evaluator.INTENT_DATA_VALUES, v);
	}
	
	private void initDataViews() {
		Intent i = getIntent();
		
		String[] s = i.getStringArrayExtra(Evaluator.INTENT_DATA_NAMES);
		int[] v = i.getIntArrayExtra(Evaluator.INTENT_DATA_VALUES);
		dynamicConfigContainer = (LinearLayout)findViewById(R.id.linearLayoutEvalConfParams);
		for (int j = 0; j < s.length; j++) {
			TextView tv = new TextView(StrategyConfig.this);
			tv.setText(s[j]);
			dynamicConfigContainer.addView(tv);
			EditText et = new EditText(StrategyConfig.this);
			et.setInputType(InputType.TYPE_CLASS_NUMBER);
			et.setText(Integer.toString(v[j]));
			et.setId(j);
			dynamicConfigContainer.addView(et);
		}
	}
}
